#include<iostream>
#include<string>
#include<locale.h>

template<class T>
class  Wektor
{
	T* pv;
	int roz;
public:
	Wektor(int n)
	{
		if (n < 1) n = 1;
		roz = n;
		pv = new T[roz];
	}
	~Wektor()
	{
		delete[] pv;
	}
	Wektor(const Wektor& wzor);
	T& operator=(const Wektor& wzor);
	void Wypisz()const;
	void WypiszLinia()const;
	int Rozmiar()const { return roz; }
	T& operator[](int index)const;

};

template<class S>
Wektor<S>::Wektor(const Wektor& wzor)
{
	roz = wzor.roz;
	pv = new S[roz];
	for (int i = 0; i < roz; ++i)
		pv[i] = wzor.pv[i];
}

template<class T>
T& Wektor<T>::operator=(const Wektor& wzor)
{
	if (this != &wzor)
	{
		delete[] pv;

		roz = wzor.roz;
		pv = new T[roz];
		for (int i = 0; i < roz; ++i)
			pv[i] = wzor.pv[i];

	}
	return *this;
}

template<class T>
void Wektor<T>::Wypisz() const
{
	for (int i = 0; i < roz; ++i)
		std::cout << pv[i] << std::endl;
}

template<class T>
void Wektor<T>::WypiszLinia() const
{
	for (int i = 0; i < roz; ++i)
		std::cout << pv[i] <<' ';
	std::cout << std::endl;
}

template<class T>
T& Wektor<T>::operator[](int index) const
{
	if(index<0&&index>=roz) throw std::out_of_range{ "Wektor::operator[]" };
	return pv[index];
}


int main()
{
	setlocale(LC_ALL, "pl-PL");
	Wektor<std::string> slowa(5);

	//Wektor<Wektor<double>> Macierz(10);

	Wektor<double> tablica(11);

	slowa[0] = "To";
	slowa[1] = "ju";
	slowa[2] = "ostatni";
	slowa[3] = "wykad";
	slowa[4] = "z jzyka C++";

	slowa.Wypisz();
	slowa.WypiszLinia();
}